import processing.serial.*;

PFont font;


Serial port;

Led[] led = new Led[4];

void setup() {

  size (400,300);
  smooth();

  String[] ports = Serial.list();
  println(ports); 
  port = new Serial(this, ports[1], 9600);

  port.write("abcd"); // tout eteindre à l'allumage


  font = loadFont("font-45.vlw"); 
  textFont(font);
  textAlign(CENTER, CENTER);
  for (int i = 0; i<led.length; i++)
  {
    led[i]=new Led(i, led.length);//crée le tableau avec les leds
  }

}

void draw() {
  for (int i = 0; i<led.length; i++)
  {
    led[i].Draw();
  }
}

void keyPressed() {

  String message;

  switch(key) {
  case 'a' :
    message = "a";
    port.write(message);
    return;
  case 'A' :
    message = "A";
    port.write(message);
    return;
  case 'b' :
    message = "b";
    port.write(message);
    return;
  case 'B' :
    message = "B";
    port.write(message);
    return;
  case 'c' :
    message = "c";
    port.write(message);
    return;
  case 'C' :
    message = "C";
    port.write(message);
    return;
  case 'd' :
    message = "d";
    port.write(message);
    return;
  case 'D' :
    message = "D";
    port.write(message);
    return;
  default:
    //port.write("f");
    println("invalid character");
    break;
  }

  //port.write(keyCode); 
}

void serialEvent(Serial p) {
  print((char)port.read());
}

void mousePressed()
{
  String message;
  float xpressed, ypressed;
  xpressed = mouseX;
  ypressed = mouseY;
  for (int i = 0; i<led.length; i++)
  {
    led[i].OnClick(xpressed, ypressed);//envoi la position de la souris lors du click
    switch(i) {
    case 0 :
      if (led[i].Etat()) message = "A";
      else message = "a";
      port.write(message);
      break;
    case 1 :
      if (led[i].Etat()) message = "B";
      else message = "b";
      port.write(message);
      break;
    case 2 :
      if (led[i].Etat()) message = "C";
      else message = "c";
      port.write(message);
      break;
    case 3 :
      if (led[i].Etat()) message = "D";
      else message = "d";
      port.write(message);
      break;
    }
  }
}
